diff --git a/lib/hive/commands/setup/deps.rb b/lib/hive/commands/setup/deps.rb
new file mode 100644
index 000000000..c54260702
--- /dev/null
+++ b/lib/hive/commands/setup/deps.rb
@@ -0,0 +1,254 @@
+require "open3"
+
+module Hive
+  module Commands
+    class Setup
+      # Dependency checker for `hive setup`. Verifies the local surface's
+      # required CLIs and reports a per-dep Result. Two classes of dependency:
+      #
+      #   * External agent CLIs (gh / claude / codex) are DIAGNOSE-ONLY: a
+      #     missing or unauthenticated CLI is reported `blocked` with the
+      #     exact fix command, but `hive setup` NEVER installs or
+      #     authenticates them (R10).
+      #   * Everything else (ruby/git/tmux/node/npm/sqlite3) is a hard check —
+      #     missing → ok:false with a fix command, but not "blocked" (the
+      #     operator runs the fix and re-runs setup; setup does not gate on
+      #     them itself).
+      #
+      # `qmd` and the web bundle are Hive-owned and bootstrapped by the setup
+      # orchestrator (U3/U4), not diagnosed here.
+      class Deps
+        MIN_RUBY = "3.4.0".freeze
+        MIN_CLAUDE = "2.1.118".freeze
+        MIN_CODEX = "0.125.0".freeze
+
+        # Ruby version managers and their install + select commands. The
+        # `root` segments mirror ServiceInstaller::Base::RUBY_SHIM_MANAGERS
+        # keys so the detector here and the unit-PATH builder agree on what
+        # counts as mise / rbenv / asdf. `3.4` is the version token each
+        # manager resolves to the latest 3.4.x.
+        RUBY_MANAGER_FIXES = {
+          "mise" => { root: ".local/share/mise", fix: "mise install ruby@3.4 && mise use ruby@3.4" },
+          "rbenv" => { root: ".rbenv", fix: "rbenv install 3.4 && rbenv global 3.4" },
+          "asdf" => { root: ".asdf", fix: "asdf install ruby 3.4 && asdf global ruby 3.4" }
+        }.freeze
+
+        # Fallback when no manager is detectable (system Ruby, or Ruby not
+        # yet installed with no manager CLI on PATH): point at every supported
+        # manager rather than a single hardcoded one.
+        SYSTEM_RUBY_FIX = "install Ruby 3.4 with rbenv / mise / asdf, or your OS package manager".freeze
+
+        # One row of the dependency report. `ok` = present and satisfies the
+        # gate; `blocked` = an external CLI that setup cannot fix itself
+        # (missing/unauth); `found` = parsed version (or nil); `fix` = exact
+        # command the operator must run (nil when ok).
+        Result = Struct.new(:name, :ok, :blocked, :found, :required, :message, :fix, keyword_init: true) do
+          def to_h
+            {
+              "name" => name,
+              "ok" => ok,
+              "blocked" => blocked,
+              "found" => found,
+              "required" => required,
+              "message" => message,
+              "fix" => fix
+            }
+          end
+        end
+
+        # `runner` is callable with an argv Array and returns [stdout, ok].
+        # Injectable so tests can stub `claude`/`codex`/`gh`/`qmd` on PATH.
+        def initialize(runner: nil)
+          @runner = runner || method(:run_real)
+        end
+
+        def check
+          [
+            check_ruby,
+            check_git,
+            check_tmux,
+            check_gh,
+            check_claude,
+            check_codex,
+            check_node,
+            check_sqlite3
+          ]
+        end
+
+        def blocked_names
+          check.select(&:blocked).map(&:name)
+        end
+
+        def all_ok?
+          check.all?(&:ok)
+        end
+
+        private
+
+        def run_real(argv)
+          out, _err, status = Open3.capture3(*argv)
+          [ out, status.success? ]
+        rescue Errno::ENOENT, Errno::EACCES
+          [ "", false ]
+        end
+
+        # Run `argv` and extract the first version-looking token. Returns
+        # [version, ok]; version is nil when the command failed or produced
+        # no parseable version.
+        def probe_version(argv, pattern)
+          out, ok = @runner.call(argv)
+          return [ nil, false ] unless ok
+
+          match = out.to_s[pattern]
+          [ match, !match.nil? ]
+        end
+
+        def version_tuple(version)
+          version.to_s.split(".").map(&:to_i)
+        end
+
+        def at_least?(found, min)
+          (version_tuple(found) <=> version_tuple(min)) >= 0
+        end
+
+        # Ruby 3.4 is exact (major.minor), not a floor — a 3.5/4.x Ruby would
+        # drift from the pinned .ruby-version / Gemfile.lock and fail the
+        # bundle later anyway, so say so up front.
+        def ruby_major_minor_match?(version)
+          tuple = version_tuple(version)
+          tuple[0] == 3 && tuple[1] == 4
+        end
+
+        def check_ruby
+          version, ok = probe_version(%w[ruby --version], /\d+\.\d+\.\d+/)
+          unless ok && version
+            return Result.new(name: "ruby", ok: false, blocked: false, found: nil, required: "3.4.x",
+                              message: "ruby 3.4 is required",
+                              fix: ruby_fix)
+          end
+          unless ruby_major_minor_match?(version)
+            return Result.new(name: "ruby", ok: false, blocked: false, found: version, required: "3.4.x",
+                              message: "ruby #{version} found; 3.4.x is required",
+                              fix: ruby_fix)
+          end
+          Result.new(name: "ruby", ok: true, blocked: false, found: version, required: "3.4.x",
+                     message: "ok", fix: nil)
+        end
+
+        # The fix command for a missing / wrong-version Ruby, tailored to the
+        # version manager actually in use (mise / rbenv / asdf), with a
+        # manager-agnostic fallback for system Ruby. Mirrors
+        # ServiceInstaller::Base#ruby_shim_dir's detection so the two surfaces
+        # agree on which manager is active.
+        def ruby_fix
+          RUBY_MANAGER_FIXES.dig(ruby_manager, :fix) || SYSTEM_RUBY_FIX
+        end
+
+        # Detect the active Ruby version manager: prefer the realpath of the
+        # `ruby` on PATH (matched against each manager's install root),
+        # falling back to whichever manager CLI is itself on PATH when Ruby
+        # isn't installed yet.
+        def ruby_manager
+          ruby_path = which("ruby")
+          if ruby_path
+            resolved = File.exist?(ruby_path) ? File.realpath(ruby_path) : ruby_path
+            home = File.expand_path(ENV["HOME"] || Dir.home)
+            RUBY_MANAGER_FIXES.each do |name, spec|
+              root = File.join(home, spec[:root])
+              return name if resolved.start_with?("#{root}/")
+            end
+          end
+
+          RUBY_MANAGER_FIXES.keys.find { |name| which(name) }
+        end
+
+        # Pure PATH lookup (no spawn) — the same predicate
+        # ServiceInstaller::Base uses to resolve binaries.
+        def which(name)
+          ENV["PATH"].to_s.split(File::PATH_SEPARATOR).each do |dir|
+            path = File.join(dir, name)
+            return path if File.file?(path) && File.executable?(path)
+          end
+          nil
+        end
+
+        def check_git
+          version, ok = probe_version(%w[git --version], /\d+\.\d+(?:\.\d+)?/)
+          ok ? Result.new(name: "git", ok: true, blocked: false, found: version, required: "any",
+                          message: "ok", fix: nil)
+             : Result.new(name: "git", ok: false, blocked: false, found: nil, required: "any",
+                          message: "git not found", fix: "brew install git")
+        end
+
+        def check_tmux
+          version, ok = probe_version(%w[tmux -V], /\d+\.\d+/)
+          ok ? Result.new(name: "tmux", ok: true, blocked: false, found: version, required: "any",
+                          message: "ok", fix: nil)
+             : Result.new(name: "tmux", ok: false, blocked: false, found: nil, required: "any",
+                          message: "tmux not found", fix: "brew install tmux")
+        end
+
+        def check_gh
+          version, ok = probe_version(%w[gh --version], /\d+\.\d+(?:\.\d+)?/)
+          unless ok
+            return Result.new(name: "gh", ok: false, blocked: true, found: nil, required: "authenticated",
+                              message: "gh not found", fix: "brew install gh && gh auth login")
+          end
+          unless gh_authed?
+            return Result.new(name: "gh", ok: false, blocked: true, found: version, required: "authenticated",
+                              message: "gh is installed but not authenticated", fix: "gh auth login")
+          end
+          Result.new(name: "gh", ok: true, blocked: false, found: version, required: "authenticated",
+                     message: "ok", fix: nil)
+        end
+
+        def gh_authed?
+          _out, ok = @runner.call(%w[gh auth status])
+          ok
+        end
+
+        def check_claude
+          check_agent_cli("claude", MIN_CLAUDE)
+        end
+
+        def check_codex
+          check_agent_cli("codex", MIN_CODEX)
+        end
+
+        def check_agent_cli(name, min_version)
+          version, ok = probe_version([ name, "--version" ], /\d+\.\d+\.\d+/)
+          unless ok
+            return Result.new(name: name, ok: false, blocked: true, found: nil, required: ">= #{min_version}",
+                              message: "#{name} not found",
+                              fix: "brew install #{name} && #{name} login")
+          end
+          unless at_least?(version, min_version)
+            return Result.new(name: name, ok: false, blocked: true, found: version, required: ">= #{min_version}",
+                              message: "#{name} #{version} below minimum #{min_version}",
+                              fix: "brew upgrade #{name}")
+          end
+          Result.new(name: name, ok: true, blocked: false, found: version, required: ">= #{min_version}",
+                     message: "ok", fix: nil)
+        end
+
+        def check_node
+          node, node_ok = probe_version(%w[node --version], /\d+\.\d+\.\d+/)
+          npm, npm_ok = probe_version(%w[npm --version], /\d+\.\d+\.\d+/)
+          ok = node_ok && npm_ok
+          Result.new(name: "node/npm", ok: ok, blocked: false, found: ok ? "node #{node}, npm #{npm}" : nil,
+                     required: "any",
+                     message: ok ? "ok" : "node or npm not found",
+                     fix: ok ? nil : "brew install node")
+        end
+
+        def check_sqlite3
+          version, ok = probe_version(%w[sqlite3 --version], /\d+\.\d+\.\d+/)
+          ok ? Result.new(name: "sqlite3", ok: true, blocked: false, found: version, required: "any",
+                          message: "ok", fix: nil)
+             : Result.new(name: "sqlite3", ok: false, blocked: false, found: nil, required: "any",
+                          message: "sqlite3 not found", fix: "brew install sqlite")
+        end
+      end
+    end
+  end
+end
diff --git a/lib/hive/commands/setup/web_bundle.rb b/lib/hive/commands/setup/web_bundle.rb
new file mode 100644
index 000000000..f44d202e1
--- /dev/null
+++ b/lib/hive/commands/setup/web_bundle.rb
@@ -0,0 +1,167 @@
+require "fileutils"
+require "open3"
+require "hive/paths"
+
+module Hive
+  module Commands
+    class Setup
+      # Web bundle provisioning for the first-class LOCAL mode (U4). The gem
+      # does not package the Rails app (ADR-037), so `hive setup` obtains and
+      # bundles it separately, pinned to the installed gem version so the web
+      # tier and CLI agree.
+      #
+      # Resolution order: HIVEBOX_WEB_APP_DIR → managed `~/.local/share/hive/web`
+      # → sibling source checkout. When nothing resolves, fetch the release
+      # tarball for `v#{Hive::VERSION}` (git clone --depth 1 --branch fallback)
+      # into the managed dir, keep only `web/`, then `bundle install`
+      # (BUNDLE_GEMFILE=web/Gemfile) and `bin/rails db:prepare`. A marker file
+      # records the pinned version so `hive setup` / `hive web` can warn (and
+      # re-fetch) when the managed bundle drifts from `Hive::VERSION`.
+      class WebBundle
+        MARKER_FILENAME = ".hive-web-version".freeze
+
+        # `fetcher` is callable with (target_dir) and returns {ok:, message:};
+        # injectable so tests never touch the network. `runner` is callable
+        # with an argv Array and returns [stdout, ok].
+        def initialize(fetcher: nil, runner: nil)
+          @fetcher = fetcher || method(:default_fetch)
+          @runner = runner || method(:run_real)
+        end
+
+        # Provision the bundle. Returns { ok:, message:, app_dir: }. Idempotent:
+        # an already-present, version-matching bundle only re-runs the
+        # idempotent bundle/db steps; a stale managed bundle is re-fetched.
+        def provision
+          existing = resolve_app_dir
+          dir = existing || Hive::Paths.managed_web_dir
+
+          if existing.nil? || stale_managed?(dir)
+            result = @fetcher.call(dir)
+            return { ok: false, message: result[:message], app_dir: dir } unless result[:ok]
+          end
+
+          install = bundle_install(dir)
+          return { ok: false, message: install[:message], app_dir: dir } unless install[:ok]
+
+          db = db_prepare(dir)
+          return { ok: false, message: db[:message], app_dir: dir } unless db[:ok]
+
+          write_marker(dir) if managed_dir?(dir)
+
+          { ok: true, message: "web bundle ready at #{dir}", app_dir: dir }
+        end
+
+        # Resolution order: env override → managed dir → sibling source
+        # checkout. Only a dir holding `config/application.rb` counts.
+        def resolve_app_dir
+          candidates = [
+            ENV["HIVEBOX_WEB_APP_DIR"],
+            Hive::Paths.managed_web_dir,
+            File.expand_path("../../../../web", __dir__)
+          ].compact
+          candidates.find { |dir| File.file?(File.join(dir, "config", "application.rb")) }
+        end
+
+        def marker_path(dir)
+          File.join(dir, MARKER_FILENAME)
+        end
+
+        def write_marker(dir)
+          FileUtils.mkdir_p(dir)
+          File.write(marker_path(dir), "#{Hive::VERSION}\n")
+        end
+
+        # The pinned version recorded in the marker, or nil when absent.
+        def marker_version(dir)
+          path = marker_path(dir)
+          return nil unless File.file?(path)
+
+          value = File.read(path).strip
+          value.empty? ? nil : value
+        rescue SystemCallError
+          nil
+        end
+
+        # True when the managed bundle's marker disagrees with Hive::VERSION.
+        def version_mismatch?(dir)
+          pinned = marker_version(dir)
+          !pinned.nil? && pinned != Hive::VERSION
+        end
+
+        def managed_dir?(dir)
+          File.expand_path(dir) == File.expand_path(Hive::Paths.managed_web_dir)
+        end
+
+        # A managed bundle is stale when it has no marker (an older setup
+        # before markers) or a marker that disagrees with Hive::VERSION.
+        def stale_managed?(dir)
+          return false unless managed_dir?(dir)
+
+          marker_version(dir) != Hive::VERSION
+        end
+
+        private
+
+        def bundle_install(dir)
+          in_dir(dir) do
+            _out, ok = @runner.call([ "bundle", "install" ])
+            return { ok: false, message: "bundle install failed; run: cd #{dir} && bundle install" } unless ok
+          end
+          { ok: true, message: "bundle installed" }
+        end
+
+        def db_prepare(dir)
+          in_dir(dir) do
+            _out, ok = @runner.call([ "bin/rails", "db:prepare" ])
+            return { ok: false, message: "db:prepare failed; run: cd #{dir} && bin/rails db:prepare" } unless ok
+          end
+          { ok: true, message: "db prepared" }
+        end
+
+        def in_dir(dir, &blk)
+          Dir.chdir(dir, &blk)
+        end
+
+        # Fetch the matching release into the managed dir. Tries a shallow
+        # clone of the pinned tag first (git is a verified setup dep), keeps
+        # only `web/`, and records no marker (the caller writes it after a
+        # successful bundle). Returns {ok:, message:}.
+        def default_fetch(dir)
+          version = Hive::VERSION
+          tag = "v#{version}"
+          url = "https://github.com/#{Hive::REPO_OWNER}/#{Hive::REPO_NAME}.git"
+          parent = File.dirname(dir)
+          FileUtils.mkdir_p(parent)
+          tmp = File.join(parent, ".hive-web-src-#{Process.pid}-#{rand(1_000_000)}")
+          FileUtils.rm_rf(tmp)
+
+          _out, ok = @runner.call([ "git", "clone", "--depth", "1", "--branch", tag, url, tmp ])
+          unless ok
+            FileUtils.rm_rf(tmp)
+            return { ok: false,
+                     message: "could not fetch web bundle #{tag}; run: git clone --depth 1 " \
+                              "--branch #{tag} #{url} /tmp/hive-web-src && mv /tmp/hive-web-src/web #{dir}" }
+          end
+
+          web_src = File.join(tmp, "web")
+          unless File.directory?(web_src)
+            FileUtils.rm_rf(tmp)
+            return { ok: false, message: "release #{tag} has no web/ directory" }
+          end
+
+          FileUtils.rm_rf(dir)
+          FileUtils.mv(web_src, dir)
+          FileUtils.rm_rf(tmp)
+          { ok: true, message: "fetched web bundle #{tag}" }
+        end
+
+        def run_real(argv)
+          out, _err, status = Open3.capture3(*argv)
+          [ out, status.success? ]
+        rescue Errno::ENOENT, Errno::EACCES
+          [ "", false ]
+        end
+      end
+    end
+  end
+end
diff --git a/lib/hive/commands/web.rb b/lib/hive/commands/web.rb
index eb3cd40fc..2317dc90b 100644
--- a/lib/hive/commands/web.rb
+++ b/lib/hive/commands/web.rb
@@ -1,31 +1,91 @@
+require "json"
+require "time"
 require "hive/config"
+require "hive/paths"
+require "hive/pid_file"
 require "hive/web/session_secret"
 
 module Hive
   module Commands
-    # Boots the hivebox web UI — a Rails app living in web/ at the repo root
-    # (shipped in the Docker image at /app/web). hive itself stays a plain
-    # CLI gem; the web tier is only supported where the Rails app and its
-    # bundle exist: the hivebox container or a source checkout.
+    # `hive web` boots the hivebox web UI — a Rails app living in web/ at the
+    # repo root (shipped in the Docker image at /app/web, or provisioned into
+    # the managed `~/.local/share/hive/web` dir by `hive setup`). hive itself
+    # stays a plain CLI gem; the web tier is only supported where the Rails
+    # app and its bundle exist.
+    #
+    # With no subcommand, `hive web` runs the server in the foreground. With a
+    # subcommand it manages a SEPARATE per-user service (systemd-user /
+    # launchd), distinct from `hive daemon`:
+    #
+    #   install [--force]   (re)write + enable the platform-native unit
+    #   start               run the web server detached (pidfile)
+    #   stop                SIGTERM the running web server
+    #   status [--json]     running/pid/uptime + service/install state
     class Web
-      def initialize(bind: nil, port: nil)
+      include Hive::PidFile
+
+      VALID_SUBCOMMANDS = %w[install start stop status].freeze
+
+      def initialize(subcommand = nil, bind: nil, port: nil, force: false, json: false,
+                     hive_home: Hive::Paths.state_home)
+        @subcommand = subcommand
         @bind = bind
         @port = port
+        @force = force
+        @json = json
+        @hive_home = hive_home
       end
 
       def call
+        unless @subcommand.nil? || VALID_SUBCOMMANDS.include?(@subcommand)
+          raise Hive::InvalidTaskPath,
+                "hive web: unknown subcommand #{@subcommand.inspect} " \
+                "(expected: #{VALID_SUBCOMMANDS.join(', ')})"
+        end
+
+        case @subcommand
+        when nil       then run_foreground
+        when "install" then install_web_service
+        when "start"   then start_web_service
+        when "stop"    then stop_web_service
+        when "status"  then status_web_service
+        end
+      end
+
+      def pid_file
+        @pid_file ||= File.join(@hive_home, ".web.pid")
+      end
+
+      # Resolve the Rails app dir the same way both the foreground command and
+      # the ServiceInstaller do. Candidate order: HIVEBOX_WEB_APP_DIR → managed
+      # `~/.local/share/hive/web` (provisioned by `hive setup`) → sibling
+      # source checkout. A candidate only counts when it holds
+      # `config/application.rb`.
+      def self.rails_app_dir
+        candidates = [
+          ENV["HIVEBOX_WEB_APP_DIR"],
+          Hive::Paths.managed_web_dir,
+          File.expand_path("../../../web", __dir__)
+        ].compact
+        candidates.find { |dir| File.file?(File.join(dir, "config", "application.rb")) }
+      end
+
+      def run_foreground
         cfg = Hive::Config.load_global_web
         bind = @bind || cfg.fetch("bind")
         port = (@port || cfg.fetch("port")).to_i
         app_dir = rails_app_dir
         unless app_dir
           warn "hive web: the hivebox web app (web/) was not found. " \
-               "Run from the hivebox Docker image or a source checkout, " \
-               "or point HIVEBOX_WEB_APP_DIR at the Rails app."
+               "Run `hive setup` to provision it, run from the hivebox Docker " \
+               "image or a source checkout, or point HIVEBOX_WEB_APP_DIR at " \
+               "the Rails app."
           exit 1
         end
 
         warn_on_public_bind(bind, cfg)
+        refuse_unsafe_public_bind(bind, cfg)
+        warn_on_managed_bundle_mismatch(app_dir)
 
         env = {
           "RAILS_ENV" => ENV.fetch("RAILS_ENV", "production"),
@@ -64,12 +124,155 @@ module Hive
 
       private
 
+      def web_config
+        @web_config ||= Hive::Config.load_global_web
+      end
+
+      def resolved_bind
+        (@bind || web_config.fetch("bind")).to_s
+      end
+
+      def resolved_port
+        (@port || web_config.fetch("port")).to_i
+      end
+
+      def install_web_service
+        require "hive/commands/web/service_installer"
+        installer = Hive::Commands::Web::ServiceInstaller.new(binary_path: current_binary_path)
+        begin
+          result = installer.install!(autostart: true, force: @force)
+        rescue Hive::Error
+          raise
+        rescue StandardError => e
+          raise Hive::WebInstallFailed,
+                "web service install failed: #{e.class}: #{e.message}"
+        end
+        installer.messages.each { |line| warn "hive: #{line}" }
+        emit_install_summary(installer, result)
+        emit_install_outcome(installer, result)
+        # Persist the local loopback web contract (U1/R4) so a fresh
+        # `hive web install` is not left gated behind the GitHub owner flow.
+        Hive::Config.write_local_web_loopback!
+      end
+
+      def emit_install_summary(installer, outcome)
+        case outcome.kind
+        when :written
+          puts "hive web: installed unit at #{installer.target_path}"
+        when :upgraded
+          msg = "hive web: upgraded unit at #{installer.target_path}"
+          msg += " (backup: #{outcome.backup_path})" if outcome.backup_path
+          puts msg
+        when :unchanged
+          puts "hive web: unit already up to date at #{installer.target_path}"
+        when :autostart_unavailable
+          puts "hive web: unit written at #{installer.target_path}; autostart not enabled on this host"
+        when :unsupported, :drifted, :failed
+          # handled by emit_install_outcome / installer.messages
+        end
+      end
+
+      def emit_install_outcome(installer, outcome)
+        if outcome.drifted?
+          msg = "web unit at #{installer.target_path} differs from the current template. " \
+                "Re-run with `hive web install --force` to overwrite (a timestamped .bak " \
+                "will be saved)."
+          raise Hive::WebInstallDriftError, msg
+        elsif outcome.failed?
+          raise Hive::WebInstallFailed,
+                "web service install reported a failure; see messages above"
+        end
+      end
+
+      def start_web_service
+        FileUtils.mkdir_p(@hive_home)
+
+        if (existing = read_live_pid)
+          raise Hive::ConcurrentRunError.new(
+            "hive web already running (pid #{existing})",
+            holder: { pid: existing }, lock_path: pid_file
+          )
+        end
+
+        File.delete(pid_file) if File.exist?(pid_file)
+
+        Process.daemon(true, true)
+        write_own_pid_file!
+        run_foreground
+      end
+
+      def write_own_pid_file!
+        File.write(pid_file, pid_file_payload(Process.pid).to_yaml)
+      end
+
+      def stop_web_service
+        pid = read_live_pid
+        unless pid
+          File.delete(pid_file) if File.exist?(pid_file)
+          return puts("hive web: not running")
+        end
+
+        send_signal_safely(pid, :TERM)
+        deadline = Time.now + 30
+        sleep 0.2 while pid_alive?(pid) && Time.now < deadline
+        send_signal_safely(pid, :KILL) if pid_alive?(pid)
+        File.delete(pid_file) if File.exist?(pid_file)
+        puts("hive web: stopped (pid #{pid})")
+      end
+
+      def status_web_service
+        running = false
+        pid = nil
+        uptime_sec = nil
+
+        if File.exist?(pid_file)
+          payload = read_pid_file_payload
+          pid = payload && payload["pid"]
+          if pid && pid > 0 && pid_alive?(pid) && pid_owned_by_us?(payload, pid)
+            running = true
+            uptime_sec = (Time.now - File.stat(pid_file).mtime).to_i
+          end
+        end
+
+        service_state = probe_service_state
+        payload = {
+          "schema" => "hive-web-status",
+          "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-web-status"),
+          "ok" => true,
+          "running" => running,
+          "pid" => running ? pid : nil,
+          "uptime_sec" => uptime_sec,
+          "pid_file" => pid_file,
+          "service_installed" => service_state["service_installed"],
+          "service_enabled" => service_state["service_enabled"],
+          "unit_path" => service_state["unit_path"],
+          "app_dir" => rails_app_dir || Hive::Paths.managed_web_dir,
+          "bind" => resolved_bind,
+          "port" => resolved_port
+        }
+
+        if @json
+          puts JSON.generate(payload)
+        else
+          puts(running ? "hive web: running (pid #{pid}, uptime #{uptime_sec}s) at http://#{payload['bind']}:#{payload['port']}" : "hive web: not running")
+        end
+        raise Hive::Error, "web not running" if !running && !@json
+      end
+
+      def probe_service_state
+        require "hive/commands/web/service_installer"
+        Hive::Commands::Web::ServiceInstaller.new.service_state
+      rescue StandardError
+        { "service_installed" => nil, "service_enabled" => nil, "unit_path" => nil }
+      end
+
+      def current_binary_path
+        require "hive/invoked_binary"
+        Hive::InvokedBinary.path
+      end
+
       def rails_app_dir
-        candidates = [
-          ENV["HIVEBOX_WEB_APP_DIR"],
-          File.expand_path("../../../web", __dir__)
-        ].compact
-        candidates.find { |dir| File.file?(File.join(dir, "config", "application.rb")) }
+        self.class.rails_app_dir
       end
 
       # Rails' production host authorization is inactive by default — the box
@@ -83,6 +286,39 @@ module Hive
         warn "hive web: WARNING binding 0.0.0.0 without an https origin — " \
              "ensure a trusted reverse proxy validates the Host header."
       end
+
+      # U4 / R-skew mitigation: `hive web` warns when the managed bundle's
+      # pinned version marker disagrees with Hive::VERSION. Only the managed
+      # dir carries the marker; a source checkout or HIVEBOX_WEB_APP_DIR
+      # override is the operator's explicit choice and is not warned about.
+      def warn_on_managed_bundle_mismatch(app_dir)
+        return unless File.expand_path(app_dir) == File.expand_path(Hive::Paths.managed_web_dir)
+
+        require "hive/commands/setup/web_bundle"
+        return unless Hive::Commands::Setup::WebBundle.new.version_mismatch?(app_dir)
+
+        warn "hive web: the managed web bundle at #{app_dir} is pinned to a " \
+             "different version than the installed hive gem (#{Hive::VERSION}); " \
+             "re-run `hive setup` (or `hive web install --force`) to re-fetch it."
+      end
+
+      # Local loopback auth policy guard (U1): loopback binds skip GitHub
+      # owner auth, but a NON-loopback bind under web.auth_mode=loopback
+      # would expose an ownerless web tier. Refuse loudly unless the operator
+      # explicitly sets web.unsafe_public_no_auth (or switches back to the
+      # owner flow). Docker/hivebox keeps binding 0.0.0.0 with the "owner"
+      # default, so this never fires there.
+      def refuse_unsafe_public_bind(bind, cfg)
+        return if Hive::Config.web_bind_loopback?(bind)
+        return unless Hive::Config.local_web_no_auth?(cfg)
+        return if cfg["unsafe_public_no_auth"]
+
+        raise Hive::ConfigError,
+              "hive web: refusing to bind #{bind.inspect} with web.auth_mode=loopback " \
+              "(no auth). Loopback no-auth is only safe on 127.0.0.0/8 or ::1. " \
+              "Set web.auth_mode=owner (GitHub device flow), or set " \
+              "web.unsafe_public_no_auth=true to accept the risk."
+      end
     end
   end
 end
